<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1> Create Order </h1> </div>
        <div class="form-group row"><!--Combo-->
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select id="select-size" class="form-control">
              <option value="not_selected_combo"> Chọn cỡ Combo (Combo size)</option>
              <option value="S"> Nhỏ</option>
              <option value="M"> Vừa</option>
              <option value="L"> Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option value="not_selected_drink">Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row"><!--Voucher and pizza-->
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input id="inp-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher nếu có)">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select id="select-pizza" class = "form-control">            <!-- select chưa có id, các option chưa có value-->
              <option value="not_selected_pizza"> Chọn loại pizza </option>
              <option value = "Seafood" > Hải sản</option>
              <option value = "Hawaii"> Ha wai </option>
              <option value = "Bacon" > Thịt hun khói </option>
            </select>
          </div>        
        </div>
        <div class="form-group row"><!--Personal information 1-->
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input id="inp-full-name" type="text" class="form-control" placeholder="Họ và tên"> 
          </div>
          <label for="" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-4">
            <input id="inp-email" type="email" class="form-control" placeholder="Email"> 
          </div>
        </div>
        <div class="form-group row"><!--Personal information 2-->
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input id="inp-phone-number"type="text" class="form-control" placeholder="Số điện thoại">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input id="inp-address" type="text" class="form-control" placeholder="Địa chỉ"> 
          </div>
        </div>
        <div class="form-group"> <!--Message-->
          <label>Lời nhắn</label>
          <textarea id="inp-message" class="form-control h-75" placeholder="Lời nhắn (nếu cần)"></textarea>
        </div> 
        <div class="form-group"> <!--Buttons-->
          <button id="btn-create-order" class="btn btn-primary" onclick="onCreateOrderClick()">Create Order</button>
          <button id="btn-show-data-new-form" class="btn btn-secondary" onclick="showOderDataButtonClick()">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_CREATE_SUCCESS = 201;
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  
  function onPageLoading() {
    // load dữ liệu vào select car
    loadDataDrinkList();
  }
  
  function onCreateOrderClick(){
    console.log("%ccreate order clicked", "color:orange");

    //create an order object
    var vOrderObject = {
        id: "",
        orderCode: "",
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "",
        thanhTien: "",
        giamGia: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
        trangThai: "",
        ngayTao: "",
        ngayCapNhat: "",
    }

    //1 - get data from the web form
    getDataFromWeb(vOrderObject);

    //2 - validate the obtained data
    var vValidResult = validateDataWeb(vOrderObject);

    if (vValidResult == true){
      
        //3 - call API for creating new order
        var vXmlHttp = new XMLHttpRequest();
        callApiCreateOrder(vXmlHttp, vOrderObject);
       
       //4 - handler the created new order data
        vXmlHttp.onreadystatechange = function(){
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS){
              handleCreatedOrder(vXmlHttp.responseText);
          }
        }
    }
  }

  //function to get the data from the web form
  function getDataFromWeb(paramData){
      var vSizeElement = document.getElementById("select-size").value;
      var vDrinkElement = document.getElementById("select-drink").value;
      var vVoucherElement = document.getElementById("inp-voucher").value;
      var vPizzaElement = document.getElementById("select-pizza").value;
      var vFullNameElement = document.getElementById("inp-full-name").value;
      var vEmailElement = document.getElementById("inp-email").value;
      var vPhoneElement = document.getElementById("inp-phone-number").value;
      var vAddressElement = document.getElementById("inp-address").value;
      var vMessageElement = document.getElementById("inp-message").value;

      paramData.kichCo = vSizeElement;
      //if small size is chosen
      if (paramData.kichCo == "S"){
          paramData.duongKinh = "20";
          paramData.suon = "2";
          paramData.salad = "200";
          paramData.soLuongNuoc = "2";
          paramData.thanhTien = "150000";
      }
      //if small medium is chosen
      if (paramData.kichCo == "M"){
          paramData.duongKinh = "24";
          paramData.suon = "4";
          paramData.salad = "300";
          paramData.soLuongNuoc = "3";
          paramData.thanhTien = "200000";
      }
      //if small large is chosen
      if (paramData.kichCo == "L"){
          paramData.duongKinh = "30";
          paramData.suon = "8";
          paramData.salad = "500";
          paramData.soLuongNuoc = "4";
          paramData.thanhTien = "250000";
      }
      
      paramData.idLoaiNuocUong = vDrinkElement;
      paramData.idVoucher = vVoucherElement.trim();
      paramData.loaiPizza = vPizzaElement;
      paramData.hoTen = vFullNameElement.trim();
      paramData.email = vEmailElement.trim();
      paramData.soDienThoai = vPhoneElement.trim();
      paramData.diaChi = vAddressElement.trim();
      paramData.loiNhan - vMessageElement.trim();

    }

  //function for validating the data
  function validateDataWeb(paramData){

  if (paramData.kichCo == "not_selected_combo"){
  alert("please choose size !!!");
  return false;
  }
  if (paramData.idLoaiNuocUong == "not_selected_drink"){
  alert("please choose your drink !!!");
  return false;
  }
  if (paramData.loaiPizza == "not_selected_pizza"){
  alert("please choose type of pizza !!!");
  return false;
  }
  if (paramData.hoTen == ""){
  alert("please input your full name !!!");
  return false;
  }
  if (tocheckEmail(paramData.email) == ""){
  return false;
  }
  if (paramData.soDienThoai == ""){
  alert("please input your phone number !!!");
  return false;
  }
  if (paramData.diaChi == ""){
  alert("please input your address !!!");
  return false;
  }
  return true;
  }

  //function to check email structure
  function tocheckEmail(paramEmail){
      if (paramEmail == ""){
        alert("please input your email !!");
        return false
      }
      if (paramEmail.indexOf("@") === -1){
        alert("email is required to have '@' !!!");
        return false;
      }
      if (paramEmail.startsWith("@") === true){
        alert("email must have character before '@'");
        return false;
      }
      if (paramEmail.endsWith("@") === true){
        alert("email must have character after '@'");
        return false;
      }
      if (paramEmail.indexOf(".") === -1){
        alert("a dot '(.)' is required");
        return false;
      }
      return true
    }

  //function to call API for creating new order
  function callApiCreateOrder(paramXmlHttp, paramObject){
      paramXmlHttp.open("POST", gBASE_URL, true);
      paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramObject));
  }
  
  //function to handle the created new order data
  function handleCreatedOrder(paramOrder){
      
      //parding json to object
      var vParsingOrder = JSON.parse(paramOrder);
      console.log("%c THE ORDER IS BEING STATED: ","color:red",vParsingOrder);

      //set attribute regarding orderCode
      var vOrderCode = vParsingOrder.orderCode;
      var vShowOrderButtonElement = document.getElementById("btn-show-data-new-form");
          vShowOrderButtonElement.setAttribute("data-order-code", vOrderCode);
    }

  //function for ShowOrder Button
  function showOderDataButtonClick(){
    var vShowOrderButtonElement = document.getElementById("btn-show-data-new-form")
    var vOrderCode = vShowOrderButtonElement.dataset.orderCode;
    console.log("Order Code is: " , vOrderCode)

    //use query string to move to the page of User Detail
    const gUSER_DETAIL = "task25.50.orderDetail.html";
    var vUserSideOpen = gUSER_DETAIL + "?orderCode=" + vOrderCode;
    console.log(window.location.href = vUserSideOpen);

  }


    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  
  //call api for loading data to the list of drink
  function loadDataDrinkList() {
    var vXhttp = new XMLHttpRequest();
    vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
    vXhttp.send();
    vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
         // console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
  }

  // handle data load to select drink
  function handleLoadDataToSelectDrink(paramXhttp) {
    var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
   // console.log("array drink list = " + vArrayDrinkList.length);
    //load data to drink select
    var vElementSelectDrink = document.getElementById("select-drink");
    for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
      var vDrinkOptionElement = document.createElement("option");
      vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
      vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
      vElementSelectDrink.appendChild(vDrinkOptionElement);
    }
  }
 
</script>

</html>